;*************************************************************************
;				Constant definitions
;-------------------------------------------------------------------------
.equ	VERSION		= 0x0104

.equ	XTAL		= 8000000	; 8MHz, not critical 
.equ	BootDelay	= XTAL / 3	; 0.33s


.ifdef BootStart
.equ	CRC		= 17
.equ	VERIFY		= 19
.endif

.ifndef CRC
.equ	CRC		= 0
.endif

.ifndef VERIFY
.equ	VERIFY		= 0
.endif

.ifndef	SPH
.equ	MinBootSize	= 200
.else
.equ	MinBootSize	= 202
.endif

.equ	BootSize	= CRC + VERIFY + MinBootSize

.if CRC > 0
.equ	UartLoop	= 28		; UART loop time
.else
.equ	UartLoop	= 24
.endif


.ifdef BootStart
.equ	UserFlash	= (2*BootStart)
.equ	BootFuse	= 1
.else
.equ	BootStart	= ((FlashEnd - BootSize) / PageSize * PageSize)
.equ	UserFlash	= (2*BootStart - 2)
.endif


.equ	ESCAPE		= 0xA5		; end programming
.equ	COMMAND		= 0xA6		; Command sequence start

.equ	BADCOMMAND	= 0xA7		; command not supported
.equ	ANSWER		= 0xA8		; followed by length byte
.equ	CONTINUE	= 0xA9
.equ	SUCCESS		= 0xAA
.equ	FAIL		= 0xAB
;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.def	zerol		= r2
.def	zeroh		= r3
.def	baudl		= r4		; baud divider
.def	baudh		= r5
.def	crcl		= r6
.def	crch		= r7
;-------------------------------------------------------------------------
.def	a0		= r16		; working registers
.def	a1		= r17
.def	appl		= r18		; rjmp to application
.def	apph		= r19
.def	polynoml	= r20		; CRC polynom 0xA001
.def	polynomh	= r21

.def	twl		= r24		; wait time
.def	twh		= r25
;-------------------------------------------------------------------------
;				Using SRAM
;-------------------------------------------------------------------------
.dseg
.ifndef BufferSize
.equ	BufferSize	= PageSize
.endif
	.org		SRAM_START
PROGBUFF:		.byte 2*BufferSize
PROGBUFFEND:
.cseg
;-------------------------------------------------------------------------
;				Macros
;-------------------------------------------------------------------------
#define	TXD_0		cbi	STX_PORT, STX

#define	TXD_1		sbi	STX_PORT, STX

#define SKIP_RXD_0	sbic	SRX_PIN, SRX

#define	SKIP_RXD_1	sbis	SRX_PIN, SRX
;-------------------------------------------------------------------------
