;-------------------------------------------------------------------------
;		 		Program User Flash
;-------------------------------------------------------------------------
;
program:
	movw	zh:zl, zeroh:zerol	; z = 0x0000
	ldi	xl, low (ProgBuff)
	ldi	xh, high(ProgBuff)
	movw	yh:yl, xh:xl
;------------------------------ Receive data into buffer -----------------
	clt				; end mark received clear
_pro1:
	rcall	getchar
	cpi	a0, ESCAPE		; end sequence ?
	brne	_pro2
	rcall	getchar
	cpi	a0, ESCAPE
	set				; end mark received set
	brne	_pro3
	clt
_pro2:
	st	x+, a0
	cpi	xl, low (ProgBuffEnd)
	ldi     a0, high(ProgBuffEnd)
	cpc	xh, a0
	brne	_pro1
;-------------------------------------------------------------------------
_pro3:
	cp	xl, yl
	cpc	xh, yh
	breq	_pro6			; no new page, get out
	ldi	xl, low (ProgbuffEnd)
	ldi	xh, high(ProgBuffEnd)
	subi	zl, low (-2*BufferSize)
	sbci	zh, high(-2*BufferSize)	; point to next buffer
;------------------------------ Fill page buffer -------------------------
_pro4:
	sbiw	zh:zl, 2
	ld	r1, -x			; fill buffer downward
	ld	r0, -x
	ldi	a0, 1<<SPMEN		; fill buffer command
	rcall	do_spm
	movw	a1:a0, zh:zl
	andi	a0, low (2*Pagesize-1)
	brne	_pro4
	andi	a1, high(2*PageSize-1)	; for very big AVRs
	brne	_pro4
;------------------------------ Avoid self destruction ! -----------------
	cpi	zl, low (2*BootStart)
	ldi	a1, high(2*BootStart)
	cpc	zh, a1                  ; below bootloader ?
	brcc	_pro5
;------------------------------ Erase page -------------------------------
	ldi	a0, 1<<PGERS^1<<SPMEN
	rcall	do_spm
;------------------------------ Program page -----------------------------
	ldi	a0, 1<<PGWRT^1<<SPMEN	; write page command
	rcall	do_spm_rerww
	cp	xl, yl
	cpc	xh, yh
	brne	_pro4
	brts	_pro6			; get out
;------------------------------ Next Buffer ------------------------------
	subi	zl, low (-2*BufferSize)
	sbci	zh, high(-2*BufferSize)
	ldi	a0, CONTINUE
	rcall	putchar
	rjmp	_pro1
;-------------------------------------------------------------------------
do_spm_rerww:
	rcall	do_spm
	ldi	a0, 1<<RWWSRE^1<<SPMEN
do_spm:
	out	SPMCSR, a0
	spm
_dsp1:
	in	a0, SPMCSR
	sbrc	a0, SPMEN
	rjmp	_dsp1
	ret
;-------------------------------------------------------------------------
_pro5:
	rjmp	main_error		; error, size exceeded
_pro6:
	rjmp	main_ok
;-------------------------------------------------------------------------
