;-------------------------------------------------------------------------
;				Receive Byte
;-------------------------------------------------------------------------
;output: a0 = byte
;
getchar:
	SKIP_RXD_1			;1/2 wait for RXD = 1
	rjmp	getchar			;2
_rx1:
	SKIP_RXD_0			; wait for RXD = 0 (start bit)
	rjmp	_rx1
	ldi	a1, 8                   ;1
	movw	twh:twl, baudh:baudl    ;1
	lsr	twh                     ;1
	ror	twl                     ;1
	adiw	twh:twl, 6		;2 + 6
	rcall	wait_time		;13 + tw/2 middle of start bit
_rx2:
	rcall	wait_bit_time		;14 + tw
	lsr	a0			;1
	SKIP_RXD_0			;1
	ori	a0, 0x80		;1
;------------------------------ CRC --------------------------------------
	sbrc	a0, 7			;1
	eor	crcl, polynoml		;1 crcl.0 ^= a0.7
	lsr	crch			;1
	ror	crcl			;1
	brcc	_rx3			;1
	eor	crcl, polynoml		;1 ^0x01
_rx3:
	brcc	_rx4			;1
	eor	crch, polynomh		;1 ^0xA0
_rx4:
;-------------------------------------------------------------------------
	dec	a1			;1
	brne	_rx2			;2 = 28 + tw
	ret
;-------------------------------------------------------------------------
;				transmit byte
;-------------------------------------------------------------------------
;input: a0 = byte
;used: a1
;
putchar:
	rcall	wait_bit_time
	TXD_0
	lpm	a1, z			;3 (= 3*NOP)
	ldi	a1, 9			;1
	com	a0			;1 = 5
_tx1:
	rjmp	pc+1			;2 (= 2*NOP)
	rjmp	pc+1			;2
	rcall	wait_bit_time		;14 + tw
	lsr	a0			;1
	brcc	_tx2			;1/2
	nop				;1
	TXD_0				;2
	rjmp	_tx3			;2
_tx2:
	TXD_1				;2
	rjmp	pc+1			;2 (= 2*NOP)
_tx3:
	dec	a1			;1
	brne	_tx1			;2 = 28 + tw
	ret
;-------------------------------------------------------------------------
;	Wait 14 cycle + tw
;
wait_bit_time:
	movw	twh:twl, baudh:baudl	;1
wait_time:
	sbiw	twh:twl, 4		;2
	brcc	wait_time		;2/1
	cpi	twl, 0xFD		;1
	brcs	_wt1			;2/1 (2)
	breq	_wt1			;2/1 (3)
	cpi	twl, 0xFF		;1
	breq	_wt1			;2/1 (4/5)
_wt1:
	ret				;4 + 3 (rcall) = 14
;-------------------------------------------------------------------------
